/**
 * $Id$
 *
 * Copyright (C) shinichiro.h <shinichiro.hamaji _at_ gmail.com>
 *  http://shinh.skr.jp/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * This is an example for main_hook.c.
 *
 * This library provide --copying option even if this library is
 * dynamically linked.
 */

#include "../main_hook.c"

extern const char COPYING[];

static int gpl_main(int argc, char* argv[]) {
    int i;
    for (i = 1; i < argc; i++) {
        if (strcmp("--copying", argv[i]) == 0) {
            puts(COPYING);
            for (i++; i < argc; i++) {
                argv[i-1] = argv[i];
            }
            argc--;
            goto done;
        }
    }

    /* is this too verbose? */
/*    printf("%s is free software, covered by the GNU General Public License,\nand you are welcome to change it and/or distribute copies of it under\ncertain conditions. There is absolutely no warranty for %s.\n\n", argv[0], argv[0]); */

done:
    return quit_main_hook(argc, argv);
}

__attribute__((constructor)) static void gpl_init() {
    init_main_hook(&gpl_main);
}
